pro stat_map, med, sig, map=map, weightmap=weightmap, noise_level=noise_level


;;; estimates an approximate background level and dispersion of an image
;;; (used to define source masks)

;;;;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

;;; copyright 2007-2012 H\'el\`ene Roussel
;;; roussel@iap.fr
;;; Institut d'Astrophysique de Paris - Universit\'e Pierre et Marie Curie, France

;;; download and documentation: http://www2.iap.fr/users/roussel/herschel/

;;; Scanamorphos is distributed under the terms of the GNU General Public License
;;; (http://www.gnu.org/licenses/gpl.html).

;;; July 2010: public release version 1

;;;;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~



w = where(weightmap gt 0. and finite(map) gt 0)
thres_weight = 0.4 * median(weightmap(w))
w = where(weightmap gt thres_weight and finite(map) gt 0)
binsize = max([noise_level / 3., (max(map(w)) - min(map(w))) / 1000.])
binsize = min([binsize, (max(map(w)) - min(map(w))) / 100.])
histo = histogram(map(w), locations=sb, binsize=binsize)
m = max(histo, ind)
w = where(histo gt m / 20., cw)
med = sb(w(0))
if sb(ind) - med le (Machar()).eps then lim = sb(w(cw-1)) else lim = sb(ind)
w = where(weightmap gt thres_weight and finite(map) gt 0 and map le lim)
sig = sqrt(mean((map(w) - med)^2.))
if sig lt 10. * noise_level then for k = 0, 9 do begin
   if sig gt (Machar()).eps then begin
      w = where(weightmap gt thres_weight and map - med le 2.5 * sig)
      binsize = max([noise_level / 3., (med + 2. * sig - min(map(w))) / 1000.])
      binsize = min([binsize, (med + 2. * sig - min(map(w))) / 100.])
      histo = histogram(map(w), locations=sb, binsize=binsize)
      m = max(histo, ind)
      w = where(histo gt m / 20., cw)
      med = sb(ind)
      if med - sb(w(0)) le (Machar()).eps then lim = sb(w(cw-1)) else lim = med
      w = where(weightmap gt thres_weight and map le lim)
      sig = sqrt(mean((map(w) - med)^2.))
      w = where(weightmap gt thres_weight and abs(map - med) le 2. * sig)
      med = median(map(w))
   endif else sig = noise_level / 3.
endfor else sig = 10. * noise_level

end
